/* --------------------------------------------------------------------------
 * BreakOut
 * --------------------------------------------------------------------------
 * prog:  Max Rheiner 
 * date:  26/09/2012 (m/d/y)
 * ----------------------------------------------------------------------------
 */

import ddf.minim.*;

Minim minim;
AudioSample ballHitSnd;
AudioSample ballHitSchlaegerSnd;
AudioSample candyDropRacketSnd;
AudioPlayer gameOver;
AudioPlayer soundTrack;

BouncingBall ball;
Racket       schlaeger = null;
Brick[]      brickList = null;

final static int GAME_MODE_MENU      = 0;
final static int GAME_MODE_PLAY      = 1;
final static int GAME_MODE_GAMEOVER  = 2;

int          gameMode = GAME_MODE_MENU;
PImage       Candy;
PFont        Dialog;
int          count=0;
boolean      soundTrigger=false;
int          s=-5;


void setup()
{
  size(800, 600); 

  ball = new BouncingBall(width/2, height/2, 30);

  schlaeger = new Racket(0, height - 40, 150, 10);   

  // sound init
  minim = new Minim(this);
  //ballHitSnd = minim.loadSample("waterdrop.mp3");
  ballHitSchlaegerSnd = minim.loadSample("waterdrop.mp3");
  //candyDropRacketSnd = minim.loadSample("waterdrop.mp3");
  gameOver = minim.loadFile("drum.mp3");
  soundTrack = minim.loadFile("electro_billy.mp3");
  

  smooth(); 
  noCursor();
}

void initGameScene()
{
  
  
  
  // setzte die start posititon des balles
  ball.set(new PVector(width/2, height/2), new PVector(random(-7, 7), -7), 1);

  // erzeuge die ziegel
  brickList = new Brick[24];    //(int)random(3, 20)];
  for (int i=0;i < brickList.length;i++)
  {
    brickList[i] = new Brick(50 + (i % 12) * 55+(int)(i/12)*50, 200 + 50 * (int)(i/12), 50, 50);
  }
 
}


void draw()
{
  // ghosting
  fill(250, 224, 224, 100);
  rect(0, 0, width, height);
  Dialog = loadFont("Dialog-48.vlw");
  drawScene();
}

void drawScene()
{
  switch(gameMode)
  {
  case GAME_MODE_MENU:
    drawMenu();
    break;
  case GAME_MODE_PLAY:
    drawGame();
    break;  
  case GAME_MODE_GAMEOVER:
    drawGameOver();
    break;
  }
}

void drawMenu()
{
  pushStyle();
  fill(245, 133, 133);

  textSize(40);
  text("GimmeCandy", 260, 300);  

  fill(250, 150, 150);
  textSize(15);
  text("\'c\' : start game", 550, 500);  
  text("Space : stop game", 550, 550);   
  popStyle();
  
  Candy = loadImage("candy.png");
  s+=2;
  image(Candy,s, 100,120,100);
  
  if (gameMode == GAME_MODE_GAMEOVER)
  {
   gameOver.play();
  }
  
  else
  soundTrack.play();
}

void drawGameOver()
{
  imageMode(CENTER);
  Candy = loadImage("candy.png");
  //pushStyle();
  //fill(255);
  //text("Game Over", 350, 200);  
  image(Candy, width/2, height/2,random(190,200),random(140,150));
  //popStyle();
  
  //gameOver.play();
  

/*if(soundTrigger==false)
{
  gameOver.trigger();
  soundTrigger = true;
}*/
  
}

void drawGame()
{
  // update die daten, berechne kollisionen
  updateScene();


  // zeichne ziegel
  for (int i=0;i < brickList.length;i++)
  {
    if (brickList[i] != null)
      brickList[i].draw();
  }

  // zeichne den ball
  ball.draw();

  if (mousePressed == true) {
    ball.setToRacket();
  }

  // zeichne schlaeger
  schlaeger.draw();
}

void mousePressed() 
{
  ball.setToRacket();
}

void keyPressed()
{
  switch(key)
  {
  case 'c':
    // start game
    gameMode = GAME_MODE_PLAY;
    initGameScene();
    soundTrigger=false;
    break;
  case ' ':
    // end
    gameMode = GAME_MODE_MENU;
    break;
  }
}

void  updateScene()
{


  

  fill(250, 127, 127);
 textSize(15);
 text("Candy",20,40);
 textSize(25);
  text((int)count, 80, 40);


  /*for (int i=0;i < brickList.length;i++)
   {
   text((brickList[i]._count), 20, 20);
   }
   */

  count = 0;
  for (int i=0;i < brickList.length;i++)
  {
    if (brickList[i]._life==-1)
    {
      count+=1;
      //break;
    }
  }


  // test ob ball aus dem spielfeld ist
  if (ball._pos.y > height- ball._r)
  {
    gameMode = GAME_MODE_GAMEOVER;
    return;
  }

  // update schlaeger pos
  schlaeger.move(mouseX, mouseY);

  PVector hitPos = new PVector();
  float  hitV;
  float  speed;

  // teste ob ball den schlaeger trifft
  int retVal = schlaeger.checkCollision(ball._pos.x, ball._pos.y, ball._r, ball._dir, hitPos);
  switch(retVal)
  {
  case Brick.HIT_LEFT:
    // aendere flugrichtung ball
    ball._dir.x *= -1;

    // setzte ball buendig auf den schlaeger(das er nicht im schlaeger ist)
    ball._pos.x = schlaeger._pos.x - schlaeger._w/2 - ball._r;

    // spiele sound
    ballHitSchlaegerSnd.trigger();
    break;
  case Brick.HIT_RIGTH:
    // aendere flugrichtung ball
    ball._dir.x *= -1;

    // setzte ball buendig auf den schlaeger(das er nicht im schlaeger ist)
    ball._pos.x = schlaeger._pos.x + schlaeger._w/2 + ball._r;

    // spiele sound
    ballHitSchlaegerSnd.trigger();
    break;
  case Brick.HIT_TOP:
    // aendere flugrichtung ball

    // anschnitt berechnen 
    hitV = hitPos.x - (schlaeger._pos.x - schlaeger._w/2);
    hitV = 1.0 / schlaeger._w * hitV - 0.5;

    speed = ball._dir.mag();

    ball._dir.x += hitV * 8; 
    ball._dir.y *= -1;

    // ball soll die gleiche geschwindigkeit haben wie am anfang
    ball._dir.normalize();
    ball._dir.mult(speed);

    // setzte ball buendig auf den schlaeger(das er nicht im schlaeger ist)
    ball._pos.y = schlaeger._pos.y - schlaeger._h/2 - ball._r ;

    // spiele sound
    ballHitSchlaegerSnd.trigger();
    break; 
  case Brick.HIT_BOTTOM:
    // aendere flugrichtung ball

    // anschnitt berechnen 
    hitV = hitPos.x - (schlaeger._pos.x - schlaeger._w/2);
    hitV = 1.0 / schlaeger._w * hitV - 0.5;

    speed = ball._dir.mag();

    ball._dir.x += hitV * 8; 
    ball._dir.y *= -1;

    // ball soll die gleiche geschwindigkeit haben wie am anfang
    ball._dir.normalize();
    ball._dir.mult(speed);

    // setzte ball buendig auf den schlaeger(das er nicht im schlaeger ist)
    ball._pos.y = schlaeger._pos.y + schlaeger._h/2 + ball._r ;

    // spiele sound
    ballHitSchlaegerSnd.trigger();
    break;
  }

  // test ob ball einen ziegel trifft
  for (int i=0;i < brickList.length;i++)
  {
    if (brickList[i] != null)
    {
      retVal = brickList[i].checkCollision(ball._pos.x, ball._pos.y, ball._r, ball._dir, hitPos);
      switch(retVal)
      {
      case Brick.HIT_LEFT:
        brickList[i]._life=1;
      case Brick.HIT_RIGTH:
        // aendere flugrichtung ball
        ball._dir.x *= -1;

        // entferne ziegel aus liste
        // if (brickList[i]._life == 2)

        brickList[i]._life=1;

        // else

        //brickList[i]._life = null;}

        // spiele sound
        //ballHitSnd.trigger();
        break;
      case Brick.HIT_TOP:
        brickList[i]._life=1;
      case Brick.HIT_BOTTOM:
        // aendere flugrichtung ball
        ball._dir.y *= -1;

        // entferne ziegel aus liste
        brickList[i]._life=1;



        // spiele sound
        //ballHitSnd.trigger();
        break;
      }
    }
  }
}

